package sun.awt.windows;

import java.awt.Point;
import sun.awt.dnd.SunDragSourceContextPeer;
import java.awt.event.MouseEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.Component;
import java.awt.dnd.DragSource;
import java.awt.dnd.MouseDragGestureRecognizer;

final class WMouseDragGestureRecognizer extends MouseDragGestureRecognizer
{
    private static final long serialVersionUID = -3527844310018033570L;
    protected static int motionThreshold;
    protected static final int ButtonMask = 7168;
    
    protected WMouseDragGestureRecognizer(DragSource ds, Component c, int act, DragGestureListener dgl) {
        super(ds, c, act, dgl);
    }
    
    protected WMouseDragGestureRecognizer(DragSource dragSource, Component component, int n) {
        this(dragSource, component, n, null);
    }
    
    protected WMouseDragGestureRecognizer(DragSource dragSource, Component component) {
        this(dragSource, component, 0);
    }
    
    protected WMouseDragGestureRecognizer(DragSource dragSource) {
        this(dragSource, null);
    }
    
    protected int mapDragOperationFromModifiers(MouseEvent mouseEvent) {
        int modifiersEx = mouseEvent.getModifiersEx();
        int n = modifiersEx & 0x1C00;
        if (n != 1024 && n != 2048 && n != 4096) {
            return 0;
        }
        return SunDragSourceContextPeer.convertModifiersToDropAction(modifiersEx, this.getSourceActions());
    }
    
    @Override
    public void mouseClicked(MouseEvent mouseEvent) {
    }
    
    @Override
    public void mousePressed(MouseEvent awtie) {
        this.events.clear();
        if (this.mapDragOperationFromModifiers(awtie) != 0) {
            try {
                WMouseDragGestureRecognizer.motionThreshold = DragSource.getDragThreshold();
            }
            catch (Exception ex) {
                WMouseDragGestureRecognizer.motionThreshold = 5;
            }
            this.appendEvent(awtie);
        }
    }
    
    @Override
    public void mouseReleased(MouseEvent mouseEvent) {
        this.events.clear();
    }
    
    @Override
    public void mouseEntered(MouseEvent mouseEvent) {
        this.events.clear();
    }
    
    @Override
    public void mouseExited(MouseEvent mouseEvent) {
        if (!this.events.isEmpty() && this.mapDragOperationFromModifiers(mouseEvent) == 0) {
            this.events.clear();
        }
    }
    
    @Override
    public void mouseDragged(MouseEvent awtie) {
        if (!this.events.isEmpty()) {
            int mapDragOperationFromModifiers = this.mapDragOperationFromModifiers(awtie);
            if (mapDragOperationFromModifiers == 0) {
                return;
            }
            Point point = ((MouseEvent)this.events.get(0)).getPoint();
            Point point2 = awtie.getPoint();
            int abs = Math.abs(point.x - point2.x);
            int abs2 = Math.abs(point.y - point2.y);
            if (abs > WMouseDragGestureRecognizer.motionThreshold || abs2 > WMouseDragGestureRecognizer.motionThreshold) {
                this.fireDragGestureRecognized(mapDragOperationFromModifiers, ((MouseEvent)this.getTriggerEvent()).getPoint());
            }
            else {
                this.appendEvent(awtie);
            }
        }
    }
    
    @Override
    public void mouseMoved(MouseEvent mouseEvent) {
    }
}
